.386
.model flat, stdcall
option casemap:none
option readonly

include windows.inc
include kernel32.inc
include user32.inc
include comctl32.inc

include asm_memory.inc
include asm_strings.inc
include asm_wnd.inc

include TestZipLib.inc

.const
align 4
ProgressDlgProcMsgMap dd WM_COMMAND, OnProgressDlgCommandMsg
	dd WM_APP_FILECOUNT, OnUpdateFileCount
	dd WM_APP_UPDATE_BAR, OnUpdateProgressBar
	dd WM_CLOSE, OnClose
	dd WM_NULL, NULL


align 4
col1Hdr     db 'Status', 0
col2Hdr     db 'Entries', 0
col3Hdr     db 'Filespec', 0

Extension1_Text     db '*.zip', 0
Extension2_Text     db '*.*', 0

.code

align 4
OnMainInitDialog proc uses ebx esi hWndDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    LOCAL szDriveList[128]  :byte
    LOCAL lvColumn          :LV_COLUMN

    ; get a list of drives on the system    
    lea esi, [szDriveList]
    invoke GetLogicalDriveStrings, sizeof szDriveList, esi
    
    ; get the window handle of the drive-combobox
    invoke GetDlgItem, [hWndDlg], IDC_COMBO_DRIVE
    mov ebx, eax

    ; add all the drives to the combobox-dropdown
align 4
@@: cmp dword ptr [esi], 0
    je short @F
    
    invoke SendMessage, ebx, CB_ADDSTRING, 0, esi
    invoke strLength, esi
    add esi, eax
    add esi, 1 ; skip NULL
    jmp short @B
    
@@:
    ; select the first entry in combobox-dropdown as showing
    invoke SendMessage, ebx, CB_SETCURSEL, 0, 0
            
    ; get the window handle of the mask-combobox
    invoke GetDlgItem, [hWndDlg], IDC_COMBO_EXTENSION	    
    mov ebx, eax

    ; add the two search mask values to the comobox-dropdown
    ; and select the first one
    invoke SendMessage, ebx, CB_ADDSTRING, 0, offset Extension1_Text
    invoke SendMessage, ebx, CB_ADDSTRING, 0, offset Extension2_Text
    invoke SendMessage, ebx, CB_SETCURSEL, 0, 0

    ; get the window handle to our list control
    lea esi, [lvColumn]
    invoke GetDlgItem, [hWndDlg], IDC_LISTVIEW_FILES
    mov ebx, eax

    ; set up the three header columns
    mov ecx, offset col1Hdr 
    mov [esi].LV_COLUMN.imask, (LVCF_TEXT or LVCF_FMT or LVCF_WIDTH)
    mov [esi].LV_COLUMN.fmt, LVCFMT_LEFT
    mov [esi].LV_COLUMN.lx, 48
    mov [esi].LV_COLUMN.pszText, ecx
    invoke SendMessage, ebx, LVM_INSERTCOLUMN, 1, esi 
    
    mov ecx, offset col2Hdr
    mov [esi].LV_COLUMN.pszText, ecx
    invoke SendMessage, ebx, LVM_INSERTCOLUMN, 2, esi 
    
    mov ecx, offset col3Hdr
    mov [esi].LV_COLUMN.lx, 335
    mov [esi].LV_COLUMN.pszText, ecx
    invoke SendMessage, ebx, LVM_INSERTCOLUMN, 3, esi 

    ret
OnMainInitDialog endp


align 4
OnClickButtonStart proc private uses ebx esi edi hWndDlg:dword, hButton:dword
    ; esi = hWndDlg
    ; edi = hWndChild
    mov esi, [hWndDlg]

    ; set up our message map data -- a list of functions that will be called
    push offset ProgressDlgProcMsgMap
    call setHookData

    ; create our dialog
    invoke GetModuleHandle, NULL
    mov ecx, offset DefaultDlgProc
    invoke CreateDialogParam, eax, IDD_PROGRESS_DIALOG, [hWndDlg], ecx, 0
    mov edi, eax

    ; center on parent and show it
    invoke CenterWindow, esi, edi
    invoke ShowWindow, edi, SW_SHOWNORMAL
    invoke UpdateWindow, edi

    ; create an object with specific thread data
    invoke asm_AllocMemory, sizeof THREAD_INFO
    test eax, eax
    je done
    mov ebx, eax

    xor eax, eax
    invoke CreateEvent, eax, eax, eax, eax
    mov [ebx].THREAD_INFO.hThreadExecute, eax

    invoke GetDlgItem, esi, IDC_LISTVIEW_FILES
    mov ecx, [hButton]
    mov [ebx].THREAD_INFO.hListCtrl, eax
    mov [ebx].THREAD_INFO.hButton, ecx
    mov [ebx].THREAD_INFO.hDlg, edi

    invoke SendMessage, eax, LVM_DELETEALLITEMS, 0, 0
    invoke UpdateWindow, [ebx].THREAD_INFO.hListCtrl

    invoke GetDlgItem, esi, IDC_COMBO_DRIVE
    mov edi, eax

    invoke SendMessage, edi, CB_GETCURSEL, 0, 0
    lea ecx, [ebx].THREAD_INFO.szDrive
    invoke SendMessage, edi, CB_GETLBTEXT, eax, ecx

    invoke GetDlgItem, esi, IDC_COMBO_EXTENSION
    mov edi, eax

    invoke SendMessage, edi, CB_GETCURSEL, 0, 0
    lea ecx, [ebx].THREAD_INFO.szExt
    invoke SendMessage, edi, CB_GETLBTEXT, eax, ecx

    invoke SetWindowLongPtr, [ebx].THREAD_INFO.hButton, GWLP_USERDATA, ebx
    invoke CreateThread, NULL, 0, offset DoWork, ebx, 0, NULL
    mov [ebx].THREAD_INFO.hThread, eax

done:
    ret
OnClickButtonStart endp


align 4
OnMainDlgCommandMsg proc hWndDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    mov eax, [wParam]
	and eax, 0FFFFh

	.if eax == IDC_BTN_START
        invoke OnClickButtonStart, [hWndDlg], [lParam]
    .endif
    ret
OnMainDlgCommandMsg endp
    

align 4
OnClose proc hWndDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	invoke DestroyWindow, [hWndDlg]
    ret
OnClose endp


align 4
OnNcDestroy proc hWndDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    invoke PostQuitMessage, NULL
    ret
OnNcDestroy endp


END