.386
.model flat
option casemap:none
option readonly

include windows.inc
include kernel32.inc
include user32.inc
include comctl32.inc

include asm_fileio.inc
include asm_memory.inc
include asm_strings.inc
include asm_wnd.inc
include asm_zip.inc

include TestZipLib.inc


externdef stdcall dwtoa     :proto stdcall :dword, :dword


.const
align 4
szProcessTxt      db 'Processing files...', 0
fmtStringSingle   db '%lu', 0
fmtStringDouble   db '%lu of %lu', 0


.data?
szTmpFmtBuffer    db 32 dup (?)


.code


align 4
option epilogue:none
option prologue:none
_OnProgressDlgCommandMsg@16 proc public ; referenced from outside this module
    mov eax, [esp+12]   ; wParam   parameter
    mov ecx, [esp+4]    ; hWndDlg  parameter
	and eax, 0FFFFh

    cmp eax, IDCANCEL
    jne short done

    ; IDCANCEL Button pressed handler
    push ecx
    call GetParent

    push IDC_BTN_START
    push eax
    call GetDlgItem

    push GWLP_USERDATA
    push eax
    call GetWindowLongPtr

    push [eax].THREAD_INFO.hThreadExecute
    call SetEvent

    mov ecx,[esp+4]     ; hWndDlg parameter
    push 0
    push ecx
    call EndDialog

done:
    ret 16
_OnProgressDlgCommandMsg@16 endp
option epilogue:EpilogueDef
option prologue:PrologueDef


align 4
option epilogue:none
option prologue:none
_OnUpdateFileCount@16 proc public ; referenced from outside this module
    push [esp+16]   ; lParam parameter
    push offset fmtStringSingle
    push offset szTmpFmtBuffer
    call wsprintf
    add esp, 0ch    ; wsprintf = cdecl call, so, pop params

    mov ecx, [esp+4]    ; hWndDlg parameter
    push IDC_STATIC_COUNT
    push ecx
    call GetDlgItem

    push offset szTmpFmtBuffer
    push eax
    call SetWindowText

    push [esp+4]    ; hWndDlg parameter
    call UpdateWindow

    ret 16
_OnUpdateFileCount@16 endp
option epilogue:EpilogueDef
option prologue:PrologueDef
    

align 4
option epilogue:none
option prologue:none
_OnUpdateProgressBar@16 proc public ; referenced from outside this module
    push IDC_CTRL_PROGRESS
    push [esp+4+4]      ; hWndDlg parameter
    call GetDlgItem

    push 0
    push [esp+12+4]     ; wParam parameter
    push PBM_SETPOS
    push eax
    call SendMessage

    mov edx, [esp+16]   ; lParam parameter
    mov ecx, [esp+12]   ; wParam parameter
    push edx
    push ecx
    push offset fmtStringDouble
    push offset szTmpFmtBuffer
    call wsprintf   
    add esp, 10h    ; wsprintf = cdecl call, so, pop params

    push IDC_STATIC_COUNT
    push [esp+4+4]      ; hWndDlg parameter
    call GetDlgItem

    push offset szTmpFmtBuffer
    push eax
    call SetWindowText

    push [esp+4]        ; hWndDlg parameter
    call UpdateWindow

    ret 16
_OnUpdateProgressBar@16 endp
option epilogue:EpilogueDef
option prologue:PrologueDef


align 4
option epilogue:none
option prologue:none
funcUpdateFileCount proc private
    call GetTickCount

    mov edx, [esp+8]    ; pInfo parameter
    xor ecx, ecx
    mov ecx, [edx].THREAD_INFO.dwLastTick
    add ecx, 100
    add [edx].THREAD_INFO.lMaxCount, 1
    cmp eax, ecx
    jle short noUpdateTick

    mov [edx].THREAD_INFO.dwLastTick, eax
    push [edx].THREAD_INFO.lMaxCount
    push 0
    push WM_APP_FILECOUNT
    push [edx].THREAD_INFO.hDlg
    call PostMessage

noUpdateTick:
    ret 8
funcUpdateFileCount endp
option epilogue:EpilogueDef
option prologue:PrologueDef


align 4
funcValidateZip proc stdcall private uses ebx esi edi szFilespec:dword, pInfo:dword
    local  szEntryName[MAX_PATH] : byte
    local  lvItem       :LV_ITEM
    local  dwTick       :dword
    local  zipError     :dword
    local  nZipEntries  :dword
    local  nZipBufLen   :dword
    
    lea esi, [lvItem]
    mov ebx, [pInfo]

    ; following four statements are "inline" code for the following function
    ; 'invoke asm_ZeroMemory, esi, sizeof LV_ITEM' since LV_ITEM is evenly
    ; divisible by four.
    xor eax, eax
    mov ecx, sizeof LV_ITEM / 4
    mov edi, esi
    rep stosd

    invoke asm_zipdOpenFileArchive, [szFilespec], addr zipError
    mov edi, eax

    invoke SendMessage, [ebx].THREAD_INFO.hListCtrl, LVM_GETITEMCOUNT, 0, 0
    push eax
    invoke wsprintf, offset szTmpFmtBuffer, offset fmtStringSingle, [zipError]

    pop eax
    mov ecx, offset szTmpFmtBuffer
    mov [esi].LV_ITEM.imask, LVIF_TEXT
    mov [esi].LV_ITEM.iItem, eax
    mov [esi].LV_ITEM.pszText, ecx
    invoke SendMessage, [ebx].THREAD_INFO.hListCtrl, LVM_INSERTITEM, 0, esi

    mov edx, 2
    mov ecx, [szFilespec]
    mov [esi].LV_ITEM.iItem, eax
    mov dword ptr [esi].LV_ITEM.iSubItem, edx
    mov [esi].LV_ITEM.pszText, ecx
    invoke SendMessage, [ebx].THREAD_INFO.hListCtrl, LVM_SETITEM, 0, esi

    test edi, edi
    je archiveDone

    invoke asm_zipdGetEntryCount, edi
    add eax, 1  ; need to add one for the looping process coming up
    mov [nZipEntries], eax

    invoke wsprintf, offset szTmpFmtBuffer, offset fmtStringSingle, eax

    mov ecx, offset szTmpFmtBuffer
    mov dword ptr [esi].LV_ITEM.iSubItem, 1
    mov [esi].LV_ITEM.pszText, ecx
    invoke SendMessage, [ebx].THREAD_INFO.hListCtrl, LVM_SETITEM, 0, esi

align 4
loopEntriesStart:
    cmp dword ptr [nZipEntries], 1
    je loopEntriesEnd

    sub dword ptr [nZipEntries], 1
    invoke asm_zipdOpenEntryByIndex, edi, [nZipEntries], addr szEntryName
    test eax, eax
    je short archiveError

    invoke asm_zipdCloseEntry, edi

    invoke asm_zipdOpenEntryByName, edi, addr szEntryName
    test eax, eax
    je short archiveError

    invoke asm_zipdDecompressEntry, edi, addr [nZipBufLen]
    test eax, eax
    je short archiveError

    invoke asm_zipdCloseEntry, edi
    jmp loopEntriesStart

align 4
archiveError:
    invoke asm_zipdGetLastError, edi
    invoke wsprintf, offset szTmpFmtBuffer, offset fmtStringSingle, eax
    mov ecx, offset szTmpFmtBuffer
    mov dword ptr [esi].LV_ITEM.iSubItem, 0
    mov [esi].LV_ITEM.pszText, ecx
    invoke SendMessage, [ebx].THREAD_INFO.hListCtrl, LVM_SETITEM, 0, esi
    invoke asm_zipdCloseEntry, edi
    jmp loopEntriesStart

align 4
loopEntriesEnd:
    invoke asm_zipdCloseArchive, edi
    
archiveDone:
    add [ebx].THREAD_INFO.lCurCount, 1
    invoke GetTickCount
    mov [dwTick], eax

    mov ecx, [ebx].THREAD_INFO.dwLastTick
    add ecx, 100
    cmp eax, ecx
    jle short @F    
    
    invoke PostMessage, [ebx].THREAD_INFO.hDlg, WM_APP_UPDATE_BAR, [ebx].THREAD_INFO.lCurCount, [ebx].THREAD_INFO.lMaxCount
    
    mov eax, [dwTick]
    mov [ebx].THREAD_INFO.dwLastTick, eax
@@:
    ret
funcValidateZip endp


align 4
BeginProcessing proc stdcall uses ebx esi pInfo:dword
    local searchData  :SEARCH32_FIND_DATA
    
    lea esi, [searchData]
    mov ebx, [pInfo]

    ; clear out our structure
    invoke asm_ZeroMemory, esi, sizeof SEARCH32_FIND_DATA

    ; fill in required structure variables
    lea ecx, [ebx].THREAD_INFO.szExt
    lea edx, [esi].SEARCH32_FIND_DATA.szExtMask
    invoke strCopy, edx, ecx
    
    mov eax, [ebx].THREAD_INFO.hThreadExecute
    mov [esi].SEARCH32_FIND_DATA.fnProcess, offset funcUpdateFileCount
    mov [esi].SEARCH32_FIND_DATA.fnParamData, ebx
    mov [esi].SEARCH32_FIND_DATA.hAbortEvent, eax

    lea eax, [ebx].THREAD_INFO.szDrive
    invoke asm_SearchFileDirectoryEx, eax, esi
    invoke WaitForSingleObject, [esi].SEARCH32_FIND_DATA.hAbortEvent, 0
    cmp eax, WAIT_TIMEOUT
    jne terminate

    invoke GetDlgItem, [ebx].THREAD_INFO.hDlg, IDC_STATIC_MSG
    invoke SetWindowText, eax, addr szProcessTxt

    invoke GetDlgItem, [ebx].THREAD_INFO.hDlg, IDC_CTRL_PROGRESS
    invoke SendMessage, eax, PBM_SETRANGE32, 1, [ebx].THREAD_INFO.lMaxCount
    invoke UpdateWindow, [ebx].THREAD_INFO.hDlg
    
    mov [esi].SEARCH32_FIND_DATA.fnProcess, offset funcValidateZip
    lea eax, [ebx].THREAD_INFO.szDrive
    invoke asm_SearchFileDirectoryEx, eax, esi

    invoke CloseHandle, [esi].SEARCH32_FIND_DATA.hAbortEvent

    invoke GetDlgItem, [ebx].THREAD_INFO.hDlg, IDC_CTRL_PROGRESS
    invoke SendMessage, eax, PBM_SETPOS, [ebx].THREAD_INFO.lMaxCount, 0
    invoke UpdateWindow, [ebx].THREAD_INFO.hDlg

terminate:
    ret
BeginProcessing endp


align 4
DoWork proc stdcall uses ebx pInfo:dword
    mov ebx, [pInfo]

    invoke strConvertCase, addr [ebx].THREAD_INFO.szExt, StringCaseLower

    ; do the processing
    invoke EnableWindow, [ebx].THREAD_INFO.hButton, FALSE
    invoke BeginProcessing, ebx
    invoke EnableWindow, [ebx].THREAD_INFO.hButton, TRUE

    ; close window and free resources
    invoke PostMessage, [ebx].THREAD_INFO.hDlg, WM_CLOSE, 0, 0
    invoke CloseHandle, [ebx].THREAD_INFO.hThread

    invoke asm_FreeMemory, [pInfo]
    ret
DoWork endp

END
